ReloadableResourceBundleMessageSource (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.context.support

## Class ReloadableResourceBundleMessageSource

- java.lang.Object
- - org.springframework.context.support.MessageSourceSupport
  - - org.springframework.context.support.AbstractMessageSource
    - - org.springframework.context.support.ReloadableResourceBundleMessageSource

- All Implemented Interfaces:
    Aware, HierarchicalMessageSource, MessageSource, ResourceLoaderAware

      public class ReloadableResourceBundleMessageSource
      extends AbstractMessageSource
      implements ResourceLoaderAware

  Spring-specific `MessageSource` implementation that accesses resource bundles using specified basenames, participating in the Spring `ApplicationContext`'s resource loading.

  In contrast to the JDK-based `ResourceBundleMessageSource`, this class uses `Properties` instances as its custom data structure for messages, loading them via a `PropertiesPersister` strategy from Spring `Resource` handles. This strategy is not only capable of reloading files based on timestamp changes, but also of loading properties files with a specific character encoding. It will detect XML property files as well.

  In contrast to `ResourceBundleMessageSource`, this class supports reloading of properties files through the `"cacheSeconds"` setting, and also through programmatically clearing the properties cache. Since application servers typically cache all files loaded from the classpath, it is necessary to store resources somewhere else (for example, in the "WEB-INF" directory of a web app). Otherwise changes of files in the classpath will not be reflected in the application.

  Note that the base names set as `"basenames"` property are treated in a slightly different fashion than the "basenames" property of `ResourceBundleMessageSource`. It follows the basic ResourceBundle rule of not specifying file extension or language codes, but can refer to any Spring resource location (instead of being restricted to classpath resources). With a "classpath:" prefix, resources can still be loaded from the classpath, but "cacheSeconds" values other than "-1" (caching forever) will not work in this case.

  This MessageSource implementation is usually slightly faster than `ResourceBundleMessageSource`, which builds on `ResourceBundle` - in the default mode, i.e. when caching forever. With "cacheSeconds" set to 1, message lookup takes about twice as long - with the benefit that changes in individual properties files are detected with a maximum delay of 1 second. Higher "cacheSeconds" values usually do not make a significant difference.

  This MessageSource can easily be used outside of an `ApplicationContext`: It will use a `DefaultResourceLoader` as default, simply getting overridden with the ApplicationContext's resource loader if running in a context. It does not have any other specific dependencies.

  Thanks to Thomas Achleitner for providing the initial implementation of this message source!

  Author:
    Juergen Hoeller
  See Also:
    `setCacheSeconds(int)`, `setBasenames(java.lang.String...)`, `setDefaultEncoding(java.lang.String)`, `setFileEncodings(java.util.Properties)`, `setPropertiesPersister(org.springframework.util.PropertiesPersister)`, `setResourceLoader(org.springframework.core.io.ResourceLoader)`, `DefaultPropertiesPersister`, `DefaultResourceLoader`, `ResourceBundleMessageSource`, `ResourceBundle`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected class` | `ReloadableResourceBundleMessageSource.PropertiesHolder` PropertiesHolder for caching.

  - ### Field Summary

    - ### Fields inherited from class org.springframework.context.support.MessageSourceSupport

      `logger`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ReloadableResourceBundleMessageSource()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected List<String>` | `calculateAllFilenames(String basename, Locale locale)` Calculate all filenames for the given bundle basename and Locale.
    `protected List<String>` | `calculateFilenamesForLocale(String basename, Locale locale)` Calculate the filenames for the given bundle basename and Locale, appending language code, country code, and variant code.
    `void` | `clearCache()` Clear the resource bundle cache.
    `void` | `clearCacheIncludingAncestors()` Clear the resource bundle caches of this MessageSource and all its ancestors.
    `protected ReloadableResourceBundleMessageSource.PropertiesHolder` | `getMergedProperties(Locale locale)` Get a PropertiesHolder that contains the actually visible properties for a Locale, after merging all specified resource bundles.
    `protected ReloadableResourceBundleMessageSource.PropertiesHolder` | `getProperties(String filename)` Get a PropertiesHolder for the given filename, either from the cache or freshly loaded.
    `protected Properties` | `loadProperties(Resource resource, String filename)` Load the properties from the given resource.
    `protected ReloadableResourceBundleMessageSource.PropertiesHolder` | `refreshProperties(String filename, ReloadableResourceBundleMessageSource.PropertiesHolder propHolder)` Refresh the PropertiesHolder for the given bundle filename.
    `protected MessageFormat` | `resolveCode(String code, Locale locale)` Resolves the given message code as key in the retrieved bundle files, using a cached MessageFormat instance per message code.
    `protected String` | `resolveCodeWithoutArguments(String code, Locale locale)` Resolves the given message code as key in the retrieved bundle files, returning the value found in the bundle as-is (without MessageFormat parsing).
    `void` | `setBasename(String basename)` Set a single basename, following the basic ResourceBundle convention of not specifying file extension or language codes, but in contrast to `ResourceBundleMessageSource` referring to a Spring resource location: e.g.
    `void` | `setBasenames(String... basenames)` Set an array of basenames, each following the basic ResourceBundle convention of not specifying file extension or language codes, but in contrast to `ResourceBundleMessageSource` referring to a Spring resource location: e.g.
    `void` | `setCacheSeconds(int cacheSeconds)` Set the number of seconds to cache loaded properties files.
    `void` | `setDefaultEncoding(String defaultEncoding)` Set the default charset to use for parsing properties files.
    `void` | `setFallbackToSystemLocale(boolean fallbackToSystemLocale)` Set whether to fall back to the system Locale if no files for a specific Locale have been found.
    `void` | `setFileEncodings(Properties fileEncodings)` Set per-file charsets to use for parsing properties files.
    `void` | `setPropertiesPersister(PropertiesPersister propertiesPersister)` Set the PropertiesPersister to use for parsing properties files.
    `void` | `setResourceLoader(ResourceLoader resourceLoader)` Set the ResourceLoader to use for loading bundle properties files.
    `String` | `toString()`

    - ### Methods inherited from class org.springframework.context.support.AbstractMessageSource

      `getDefaultMessage, getMessage, getMessage, getMessage, getMessageFromParent, getMessageInternal, getParentMessageSource, isUseCodeAsDefaultMessage, resolveArguments, setParentMessageSource, setUseCodeAsDefaultMessage`

    - ### Methods inherited from class org.springframework.context.support.MessageSourceSupport

      `createMessageFormat, formatMessage, isAlwaysUseMessageFormat, renderDefaultMessage, setAlwaysUseMessageFormat`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ReloadableResourceBundleMessageSource

          public ReloadableResourceBundleMessageSource()

  - ### Method Detail

    - #### setBasename

          public void setBasename(String basename)

      Set a single basename, following the basic ResourceBundle convention of not specifying file extension or language codes, but in contrast to `ResourceBundleMessageSource` referring to a Spring resource location: e.g. "WEB-INF/messages" for "WEB-INF/messages.properties", "WEB-INF/messages_en.properties", etc.

      XML properties files are also supported: .g. "WEB-INF/messages" will find and load "WEB-INF/messages.xml", "WEB-INF/messages_en.xml", etc as well.

      Parameters:
        `basename` - the single basename
      See Also:
        `setBasenames(java.lang.String...)`, `ResourceEditor`, `ResourceBundle`

    - #### setBasenames

          public void setBasenames(String... basenames)

      Set an array of basenames, each following the basic ResourceBundle convention of not specifying file extension or language codes, but in contrast to `ResourceBundleMessageSource` referring to a Spring resource location: e.g. "WEB-INF/messages" for "WEB-INF/messages.properties", "WEB-INF/messages_en.properties", etc.

      XML properties files are also supported: .g. "WEB-INF/messages" will find and load "WEB-INF/messages.xml", "WEB-INF/messages_en.xml", etc as well.

      The associated resource bundles will be checked sequentially when resolving a message code. Note that message definitions in a previous resource bundle will override ones in a later bundle, due to the sequential lookup.

      Parameters:
        `basenames` - an array of basenames
      See Also:
        `setBasename(java.lang.String)`, `ResourceBundle`

    - #### setDefaultEncoding

          public void setDefaultEncoding(String defaultEncoding)

      Set the default charset to use for parsing properties files. Used if no file-specific charset is specified for a file.

      Default is none, using the `java.util.Properties` default encoding: ISO-8859-1.

      Only applies to classic properties files, not to XML files.

      Parameters:
        `defaultEncoding` - the default charset
      See Also:
        `setFileEncodings(java.util.Properties)`, `PropertiesPersister.load(java.util.Properties, java.io.InputStream)`

    - #### setFileEncodings

          public void setFileEncodings(Properties fileEncodings)

      Set per-file charsets to use for parsing properties files.

      Only applies to classic properties files, not to XML files.

      Parameters:
        `fileEncodings` - Properties with filenames as keys and charset names as values. Filenames have to match the basename syntax, with optional locale-specific appendices: e.g. "WEB-INF/messages" or "WEB-INF/messages_en".
      See Also:
        `setBasenames(java.lang.String...)`, `PropertiesPersister.load(java.util.Properties, java.io.InputStream)`

    - #### setFallbackToSystemLocale

          public void setFallbackToSystemLocale(boolean fallbackToSystemLocale)

      Set whether to fall back to the system Locale if no files for a specific Locale have been found. Default is "true"; if this is turned off, the only fallback will be the default file (e.g. "messages.properties" for basename "messages").

      Falling back to the system Locale is the default behavior of `java.util.ResourceBundle`. However, this is often not desirable in an application server environment, where the system Locale is not relevant to the application at all: Set this flag to "false" in such a scenario.

    - #### setCacheSeconds

          public void setCacheSeconds(int cacheSeconds)

      Set the number of seconds to cache loaded properties files.
      - Default is "-1", indicating to cache forever (just like `java.util.ResourceBundle`).
      - A positive number will cache loaded properties files for the given number of seconds. This is essentially the interval between refresh checks. Note that a refresh attempt will first check the last-modified timestamp of the file before actually reloading it; so if files don't change, this interval can be set rather low, as refresh attempts will not actually reload.
      - A value of "0" will check the last-modified timestamp of the file on every message access. Do not use this in a production environment!

    - #### setPropertiesPersister

          public void setPropertiesPersister(PropertiesPersister propertiesPersister)

      Set the PropertiesPersister to use for parsing properties files.

      The default is a DefaultPropertiesPersister.

      See Also:
        `DefaultPropertiesPersister`

    - #### setResourceLoader

          public void setResourceLoader(ResourceLoader resourceLoader)

      Set the ResourceLoader to use for loading bundle properties files.

      The default is a DefaultResourceLoader. Will get overridden by the ApplicationContext if running in a context, as it implements the ResourceLoaderAware interface. Can be manually overridden when running outside of an ApplicationContext.

      Specified by:
        `setResourceLoader` in interface `ResourceLoaderAware`
      Parameters:
        `resourceLoader` - ResourceLoader object to be used by this object
      See Also:
        `DefaultResourceLoader`, `ResourceLoaderAware`

    - #### resolveCodeWithoutArguments

          protected String resolveCodeWithoutArguments(String code,
                                           Locale locale)

      Resolves the given message code as key in the retrieved bundle files, returning the value found in the bundle as-is (without MessageFormat parsing).
      Overrides:
        `resolveCodeWithoutArguments` in class `AbstractMessageSource`
      Parameters:
        `code` - the code of the message to resolve
        `locale` - the Locale to resolve the code for (subclasses are encouraged to support internationalization)
      Returns:
        the message String, or `null` if not found
      See Also:
        `AbstractMessageSource.resolveCode(java.lang.String, java.util.Locale)`, `MessageFormat`

    - #### resolveCode

          protected MessageFormat resolveCode(String code,
                                  Locale locale)

      Resolves the given message code as key in the retrieved bundle files, using a cached MessageFormat instance per message code.
      Specified by:
        `resolveCode` in class `AbstractMessageSource`
      Parameters:
        `code` - the code of the message to resolve
        `locale` - the Locale to resolve the code for (subclasses are encouraged to support internationalization)
      Returns:
        the MessageFormat for the message, or `null` if not found
      See Also:
        `AbstractMessageSource.resolveCodeWithoutArguments(String, java.util.Locale)`

    - #### getMergedProperties

          protected ReloadableResourceBundleMessageSource.PropertiesHolder getMergedProperties(Locale locale)

      Get a PropertiesHolder that contains the actually visible properties for a Locale, after merging all specified resource bundles. Either fetches the holder from the cache or freshly loads it.

      Only used when caching resource bundle contents forever, i.e. with cacheSeconds < 0. Therefore, merged properties are always cached forever.

    - #### calculateAllFilenames

          protected List<String> calculateAllFilenames(String basename,
                                           Locale locale)

      Calculate all filenames for the given bundle basename and Locale. Will calculate filenames for the given Locale, the system Locale (if applicable), and the default file.
      Parameters:
        `basename` - the basename of the bundle
        `locale` - the locale
      Returns:
        the List of filenames to check
      See Also:
        `setFallbackToSystemLocale(boolean)`, `calculateFilenamesForLocale(java.lang.String, java.util.Locale)`

    - #### calculateFilenamesForLocale

          protected List<String> calculateFilenamesForLocale(String basename,
                                                 Locale locale)

      Calculate the filenames for the given bundle basename and Locale, appending language code, country code, and variant code. E.g.: basename "messages", Locale "de_AT_oo" -> "messages_de_AT_OO", "messages_de_AT", "messages_de".

      Follows the rules defined by `Locale.toString()`.

      Parameters:
        `basename` - the basename of the bundle
        `locale` - the locale
      Returns:
        the List of filenames to check

    - #### getProperties

          protected ReloadableResourceBundleMessageSource.PropertiesHolder getProperties(String filename)

      Get a PropertiesHolder for the given filename, either from the cache or freshly loaded.
      Parameters:
        `filename` - the bundle filename (basename + Locale)
      Returns:
        the current PropertiesHolder for the bundle

    - #### refreshProperties

          protected ReloadableResourceBundleMessageSource.PropertiesHolder refreshProperties(String filename,
                                                                                 ReloadableResourceBundleMessageSource.PropertiesHolder propHolder)

      Refresh the PropertiesHolder for the given bundle filename. The holder can be `null` if not cached before, or a timed-out cache entry (potentially getting re-validated against the current last-modified timestamp).
      Parameters:
        `filename` - the bundle filename (basename + Locale)
        `propHolder` - the current PropertiesHolder for the bundle

    - #### loadProperties

          protected Properties loadProperties(Resource resource,
                                  String filename)
                                       throws IOException

      Load the properties from the given resource.
      Parameters:
        `resource` - the resource to load from
        `filename` - the original bundle filename (basename + Locale)
      Returns:
        the populated Properties instance
      Throws:
        `IOException` - if properties loading failed

    - #### clearCache

          public void clearCache()

      Clear the resource bundle cache. Subsequent resolve calls will lead to reloading of the properties files.

    - #### clearCacheIncludingAncestors

          public void clearCacheIncludingAncestors()

      Clear the resource bundle caches of this MessageSource and all its ancestors.
      See Also:
        `clearCache()`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`